package sun.java2d.windows;

import java.awt.Composite;
import sun.java2d.pipe.Region;
import sun.java2d.SurfaceData;
import sun.java2d.loops.CompositeType;
import sun.java2d.loops.GraphicsPrimitiveMgr;
import sun.java2d.loops.SurfaceType;
import sun.java2d.loops.GraphicsPrimitive;
import sun.java2d.loops.Blit;

public class GDIBlitLoops extends Blit
{
    int rmask;
    int gmask;
    int bmask;
    boolean indexed;
    
    public static void register() {
        GraphicsPrimitiveMgr.register(new GraphicsPrimitive[] { new GDIBlitLoops(SurfaceType.IntRgb, GDIWindowSurfaceData.AnyGdi), new GDIBlitLoops(SurfaceType.Ushort555Rgb, GDIWindowSurfaceData.AnyGdi, 31744, 992, 31), new GDIBlitLoops(SurfaceType.Ushort565Rgb, GDIWindowSurfaceData.AnyGdi, 63488, 2016, 31), new GDIBlitLoops(SurfaceType.ThreeByteBgr, GDIWindowSurfaceData.AnyGdi), new GDIBlitLoops(SurfaceType.ByteIndexedOpaque, GDIWindowSurfaceData.AnyGdi, true), new GDIBlitLoops(SurfaceType.Index8Gray, GDIWindowSurfaceData.AnyGdi, true), new GDIBlitLoops(SurfaceType.ByteGray, GDIWindowSurfaceData.AnyGdi) });
    }
    
    public GDIBlitLoops(SurfaceType surfaceType, SurfaceType surfaceType2) {
        this(surfaceType, surfaceType2, 0, 0, 0);
    }
    
    public GDIBlitLoops(SurfaceType surfaceType, SurfaceType surfaceType2, boolean indexed) {
        this(surfaceType, surfaceType2, 0, 0, 0);
        this.indexed = indexed;
    }
    
    public GDIBlitLoops(SurfaceType srctype, SurfaceType dsttype, int rmask, int gmask, int bmask) {
        super(srctype, CompositeType.SrcNoEa, dsttype);
        this.indexed = false;
        this.rmask = rmask;
        this.gmask = gmask;
        this.bmask = bmask;
    }
    
    public native void nativeBlit(SurfaceData p0, SurfaceData p1, Region p2, int p3, int p4, int p5, int p6, int p7, int p8, int p9, int p10, int p11, boolean p12);
    
    @Override
    public void Blit(SurfaceData surfaceData, SurfaceData surfaceData2, Composite composite, Region region, int n, int n2, int n3, int n4, int n5, int n6) {
        this.nativeBlit(surfaceData, surfaceData2, region, n, n2, n3, n4, n5, n6, this.rmask, this.gmask, this.bmask, this.indexed);
    }
}
